;calcspd
;zerocnt
;zerocc

zerocc   #inibcd cellcnt,4
         rts

calcspd .block
        lda #<eval1
        sta $3b
        lda #>eval1
        sta $3c
        jsr $932c	;eval expression
        ldy #0
loop1   lda irqcnt,y
        cmp #$30
        bne cont1

        iny
        bne loop1

cont1   ldx #0
loop2   lda irqcnt,y
        sta $c06,x
        inx
        iny
        cpy #9
        bne loop2

        lda #"S"-"A"+$81
        sta $c06,x
        ldy #0
loop3   lda $100,y
        beq exit

        sta $c2f,y
        iny
        bne loop3

exit    lda $37
        sta $33
        lda $38
        sta $34
        lda #$19
        sta $16
        jmp getkey
        .bend

boxsz    .block
xmin     = i1
ymin     = i1+1
xmax     = adjcell
ymax     = adjcell+1
curx     = adjcell2
cury     = adjcell2+1
         lda #192
         sta ymin
         lda #160
         sta xmin
         lda #0
         sta xmax
         sta ymax
         sta curx
         sta cury
         lda #<tiles ;=0
         sta currp
         lda #>tiles
         sta currp+1
loop0    lda #0
         ldy #7
loop1    ora (currp),y
         dey
         bpl loop1

         ora #0
         beq cont7

         pha
loop2    asl
         iny
         bcc loop2

         sty t1
         lda curx
         asl
         asl
         asl
         tax
         adc t1
         cmp xmin
         bcs cont2

         sta xmin
cont2    pla
         ldy #8
loop3    lsr
         dey
         bcc loop3

         sty t1
         txa
         clc
         adc t1
         cmp xmax
         bcc cont3
         
         sta xmax
cont3    ldy #0
loop4    lda (currp),y
         bne cont4

         iny
         bpl loop4

cont4    sty t1
         lda cury
         asl
         asl
         asl
         tax
         adc t1
         cmp ymin
         bcs cont5

         sta ymin
cont5    ldy #7
loop5    lda (currp),y
         bne cont6

         dey
         bpl loop5

cont6    sty t1
         txa
         clc
         adc t1
         cmp ymax
         bcc cont7

         sta ymax
cont7    jsr inccurrp
         ldx curx
         inx
         cpx #20
         beq cont8

         stx curx
         bne loop0

cont8    ldx #0
         stx curx
         ldy cury
         iny
         cpy #24
         beq cont1

         sty cury
         jmp loop0
         
cont1    lda ymax
         sbc ymin
         adc #0
         sta cury
         sec
         lda xmax
         sbc xmin
         adc #0
         sta curx
         lda xmax
         ora ymax
         rts
         .bend

adddensity
         .block
         sta adjcell2
         lda #$ff
         sta adjcell2+1
         lda density
         beq exit

loop     lda $ff1e
         lsr
         lsr
         and #7
         tax
         lda bittab,x
         eor #$ff
         and adjcell2+1
         sta adjcell2+1
         eor #$ff
         tax
         lda tab3,x
         cmp density
         bne loop

exit     lda adjcell2
         and adjcell2+1
         rts
         .bend

rndbyte  .block
         ldy #4
         lda #0
         sta adjcell2
loop     lda $ff1e
         lsr
         lsr
         and #3
         cmp #3
         bne cont1
         
         lda $ff1d
         eor $ff1f
         bne cont2

cont1    asl
         tax
         lda $ff00,x
cont2    eor $ff1e
         ora adjcell2
         sta adjcell2
         dey
         bne loop

         jsr adddensity
         tax
         lda tab3,x
         ldy #sum
         adc (adjcell),y
         sta (adjcell),y
         txa
         rts
         .bend

